@concrete mutable struct MIRKNCache{iip, T} <: AbstractBoundaryValueDiffEqCache
    order::Int                 # The order of MIRKN method
    stage::Int                 # The state of MIRKN method
    M::Int                     # The number of equations
    in_size
    f
    bc
    prob                       # SecondOrderBVProblem
    problem_type               # StandardSecondOrderBVProblem
    p                          # Parameters
    alg                        # MIRKN methods
    TU                         # MIRKN Tableau
    bcresid_prototype
    mesh                       # Discrete mesh
    mesh_dt
    k_discrete                 # Stage information associated with the discrete Runge-Kutta-Nyström method
    y
    y₀
    residual
    fᵢ_cache
    fᵢ₂_cache
    resid_size
    nlsolve_kwargs
    optimize_kwargs
    kwargs
    verbose
end

Base.eltype(::MIRKNCache{iip, T}) where {iip, T} = T

function SciMLBase.__init(
        prob::SecondOrderBVProblem, alg::AbstractMIRKN;
        dt = 0.0, adaptive = false, abstol = 1.0e-6,
        controller = NoErrorControl(), nlsolve_kwargs = (; abstol = abstol),
        optimize_kwargs = (; abstol = abstol), verbose = DEFAULT_VERBOSE, kwargs...
    )
    verbose_spec = _process_verbose_param(verbose)
    @set! alg.jac_alg = concrete_jacobian_algorithm(alg.jac_alg, prob, alg)
    iip = isinplace(prob)
    @assert (iip || isnothing(alg.optimize)) "Out-of-place constraints don't allow optimization solvers "
    t₀, t₁ = prob.tspan
    ig, T, M, Nig, u0 = __extract_problem_details(prob; dt, check_positive_dt = true)
    mesh = __extract_mesh(prob.u0, t₀, t₁, Nig)
    mesh_dt = diff(mesh)

    TU = constructMIRKN(alg, T)

    # Don't flatten this here, since we need to expand it later if needed
    y₀ = __initial_guess_on_mesh(prob, prob.u0, Nig, prob.p)
    chunksize = pickchunksize(M * (2 * Nig - 2))
    __alloc = @closure x -> __maybe_allocate_diffcache(vec(zero(x)), chunksize, alg.jac_alg)

    y = __alloc.(copy.(y₀.u))
    fᵢ_cache = __alloc(zero(u0))
    fᵢ₂_cache = __alloc(zero(u0))
    stage = alg_stage(alg)
    bcresid_prototype = zero(vcat(u0, u0))
    k_discrete = [
        __maybe_allocate_diffcache(safe_similar(u0, M, stage), chunksize, alg.jac_alg)
            for _ in 1:Nig
    ]

    residual = if iip
        __alloc.(copy.(@view(y₀.u[1:end])))
    else
        nothing
    end

    resid_size = size(bcresid_prototype)
    f,
        bc = if u0 isa AbstractVector
        prob.f, prob.f.bc
    elseif iip
        vecf! = @closure (ddu, du, u, p, t) -> __vec_f!(ddu, du, u, p, t, prob.f, size(u0))
        vecbc! = if !(prob.problem_type isa TwoPointSecondOrderBVProblem)
            @closure (
                r, du, u, p,
                t,
            ) -> __vec_so_bc!(r, du, u, p, t, prob.f.bc, resid_size, size(u0))
        else
            (
                @closure(
                    (
                        r,
                        du,
                        u,
                        p,
                    ) -> __vec_so_bc!(
                        r, du, u, p, first(prob.f.bc), resid_size[1], size(u0)
                    )
                ),
                @closure(
                    (
                        r,
                        du,
                        u,
                        p,
                    ) -> __vec_so_bc!(r, du, u, p, last(prob.f.bc), resid_size[2], size(u0))
                ),
            )
        end
        vecf!, vecbc!
    else
        vecf = @closure (du, u, p, t) -> __vec_f(du, u, p, t, prob.f, size(u0))
        vecbc = if !(prob.problem_type isa TwoPointSecondOrderBVProblem)
            @closure (du, u, p, t) -> __vec_so_bc(du, u, p, t, prob.f.bc, size(u0))
        else
            (
                @closure((du, u, p) -> __vec_so_bc(du, u, p, first(prob.f.bc), size(u0))),
                @closure((du, u, p) -> __vec_so_bc(du, u, p, last(prob.f.bc), size(u0))),
            )
        end
        vecf, vecbc
    end

    prob_ = !(prob.u0 isa AbstractArray) ? remake(prob; u0 = u0) : prob

    return MIRKNCache{iip, T}(
        alg_order(alg), stage, M, size(u0), f, bc, prob_, prob.problem_type,
        prob.p, alg, TU, bcresid_prototype, mesh, mesh_dt, k_discrete,
        y, y₀, residual, fᵢ_cache, fᵢ₂_cache, resid_size, nlsolve_kwargs,
        optimize_kwargs, (; abstol, dt, adaptive, controller, kwargs...), verbose_spec
    )
end

function SciMLBase.solve!(cache::MIRKNCache{iip, T}) where {iip, T}
    info::ReturnCode.T = ReturnCode.Success
    N = length(cache.mesh)

    sol_nlprob, info = __perform_mirkn_iteration(cache)

    solu = ArrayPartition.(cache.y₀.u[1:N], cache.y₀.u[(N + 1):end])
    odesol = SciMLBase.build_solution(
        cache.prob, cache.alg, cache.mesh, solu; retcode = info
    )
    return __build_solution(cache.prob, odesol, sol_nlprob)
end

function __perform_mirkn_iteration(cache::MIRKNCache)
    nlprob = __construct_nlproblem(cache, vec(cache.y₀), copy(cache.y₀))
    solve_alg = __concrete_solve_algorithm(nlprob, cache.alg.nlsolve, cache.alg.optimize)
    kwargs = __concrete_kwargs(
        cache.alg.nlsolve, cache.alg.optimize, cache.nlsolve_kwargs, cache.optimize_kwargs,
        cache.verbose
    )
    sol_nlprob = __internal_solve(nlprob, solve_alg; kwargs...)
    recursive_unflatten!(cache.y₀, sol_nlprob.u)

    return sol_nlprob, sol_nlprob.retcode
end

# Constructing the Nonlinear Problem
function __construct_nlproblem(cache::MIRKNCache{iip}, y::AbstractVector, y₀::AbstractVectorOfArray) where {iip}
    pt = cache.problem_type
    L = length(cache.mesh)

    eval_sol = EvalSol(__restructure_sol(y₀.u[1:L], cache.in_size), cache.mesh, cache)
    eval_dsol = EvalSol(__restructure_sol(y₀.u[(L + 1):end], cache.in_size), cache.mesh, cache)

    loss_bc = if iip
        @closure (
            du, u,
            p,
        ) -> __mirkn_loss_bc!(du, u, p, pt, cache.bc, cache.y, cache.mesh, cache)
    else
        @closure (u, p) -> __mirkn_loss_bc(u, p, pt, cache.bc, cache.y, cache.mesh, cache)
    end

    loss_collocation = if iip
        @closure (
            du,
            u,
            p,
        ) -> __mirkn_loss_collocation!(
            du, u, p, cache.y, cache.mesh, cache.residual, cache
        )
    else
        @closure (
            u,
            p,
        ) -> __mirkn_loss_collocation(u, p, cache.y, cache.mesh, cache.residual, cache)
    end

    loss = if iip
        @closure (
            du,
            u,
            p,
        ) -> __mirkn_loss!(
            du, u, p, cache.y, pt, cache.bc, cache.residual,
            cache.mesh, cache, eval_sol, eval_dsol
        )
    else
        @closure (
            u,
            p,
        ) -> __mirkn_loss(
            u, p, cache.y, pt, cache.bc, cache.mesh, cache, eval_sol, eval_dsol
        )
    end

    return __construct_nlproblem(cache, y, loss_bc, loss_collocation, loss, pt)
end

function __construct_nlproblem(
        cache::MIRKNCache{iip}, y, loss_bc::BC, loss_collocation::C,
        loss::LF, ::StandardSecondOrderBVProblem
    ) where {iip, BC, C, LF}
    (; jac_alg) = cache.alg
    N = length(cache.mesh)

    resid_bc = cache.bcresid_prototype
    L = length(resid_bc)
    resid_collocation = safe_similar(y, cache.M * (2 * N - 2))

    bc_diffmode = if jac_alg.bc_diffmode isa AutoSparse
        AutoSparse(
            get_dense_ad(jac_alg.bc_diffmode);
            sparsity_detector = __default_sparsity_detector(jac_alg.bc_diffmode),
            coloring_algorithm = __default_coloring_algorithm(jac_alg.bc_diffmode)
        )
    else
        jac_alg.bc_diffmode
    end

    cache_bc = if iip
        DI.prepare_jacobian(loss_bc, resid_bc, bc_diffmode, y, Constant(cache.p))
    else
        DI.prepare_jacobian(loss_bc, bc_diffmode, y, Constant(cache.p))
    end

    nonbc_diffmode = if jac_alg.nonbc_diffmode isa AutoSparse
        AutoSparse(
            get_dense_ad(jac_alg.nonbc_diffmode);
            sparsity_detector = __default_sparsity_detector(jac_alg.nonbc_diffmode),
            coloring_algorithm = __default_coloring_algorithm(jac_alg.nonbc_diffmode)
        )
    else
        jac_alg.nonbc_diffmode
    end

    cache_collocation = if iip
        DI.prepare_jacobian(
            loss_collocation, resid_collocation, nonbc_diffmode, y, Constant(cache.p)
        )
    else
        DI.prepare_jacobian(loss_collocation, nonbc_diffmode, y, Constant(cache.p))
    end

    J_bc = if iip
        DI.jacobian(loss_bc, resid_bc, cache_bc, bc_diffmode, y, Constant(cache.p))
    else
        DI.jacobian(loss_bc, cache_bc, bc_diffmode, y, Constant(cache.p))
    end
    J_c = if iip
        DI.jacobian(
            loss_collocation, resid_collocation, cache_collocation,
            nonbc_diffmode, y, Constant(cache.p)
        )
    else
        DI.jacobian(
            loss_collocation, cache_collocation, nonbc_diffmode, y, Constant(cache.p)
        )
    end

    jac_prototype = vcat(J_bc, J_c)

    jac = if iip
        @closure (
            J,
            u,
            p,
        ) -> __mirkn_mpoint_jacobian!(
            J, J_c, u, bc_diffmode, nonbc_diffmode, cache_bc, cache_collocation,
            loss_bc, loss_collocation, resid_bc, resid_collocation, L, cache.p
        )
    else
        @closure (
            u,
            p,
        ) -> __mirkn_mpoint_jacobian(
            jac_prototype, J_c, u, bc_diffmode, nonbc_diffmode, cache_bc,
            cache_collocation, loss_bc, loss_collocation, L, cache.p
        )
    end
    resid_prototype = vcat(resid_bc, resid_collocation)
    return __construct_internal_problem(
        cache.prob, cache.problem_type, cache.alg, loss, jac,
        jac_prototype, resid_prototype, y, cache.p, cache.M, 2 * N
    )
end

function __construct_nlproblem(
        cache::MIRKNCache{iip}, y, loss_bc::BC, loss_collocation::C,
        loss::LF, ::TwoPointSecondOrderBVProblem
    ) where {iip, BC, C, LF}
    (; nlsolve, jac_alg) = cache.alg
    N = length(cache.mesh)

    resid = vcat(
        @view(cache.bcresid_prototype[1:prod(cache.resid_size[1])]),
        safe_similar(y, cache.M * 2 * (N - 1)),
        @view(cache.bcresid_prototype[(prod(cache.resid_size[1]) + 1):end])
    )

    diffmode = if jac_alg.diffmode isa AutoSparse
        AutoSparse(
            get_dense_ad(jac_alg.diffmode);
            sparsity_detector = __default_sparsity_detector(jac_alg.diffmode),
            coloring_algorithm = __default_coloring_algorithm(jac_alg.diffmode)
        )
    else
        jac_alg.diffmode
    end

    diffcache = if iip
        DI.prepare_jacobian(loss, resid, diffmode, y, Constant(cache.p))
    else
        DI.prepare_jacobian(loss, diffmode, y, Constant(cache.p))
    end

    jac_prototype = if iip
        DI.jacobian(loss, resid, diffcache, diffmode, y, Constant(cache.p))
    else
        DI.jacobian(loss, diffcache, diffmode, y, Constant(cache.p))
    end

    jac = if iip
        @closure (
            J, u, p,
        ) -> __mirkn_2point_jacobian!(J, u, diffmode, diffcache, loss, resid, p)
    else
        @closure (
            u, p,
        ) -> __mirkn_2point_jacobian(u, jac_prototype, diffmode, diffcache, loss, p)
    end

    resid_prototype = copy(resid)
    return __construct_internal_problem(
        cache.prob, cache.problem_type, cache.alg, loss, jac,
        jac_prototype, resid_prototype, y, cache.p, cache.M, 2 * N
    )
end

function __mirkn_2point_jacobian!(J, x, diffmode, diffcache, loss_fn::L, resid, p) where {L}
    DI.jacobian!(loss_fn, resid, J, diffcache, diffmode, x, Constant(p))
    return J
end

function __mirkn_2point_jacobian(x, J, diffmode, diffcache, loss_fn::L, p) where {L}
    DI.jacobian!(loss_fn, J, diffcache, diffmode, x, Constant(p))
    return J
end

function __mirkn_mpoint_jacobian!(
        J, _, x, bc_diffmode, nonbc_diffmode, bc_diffcache, nonbc_diffcache, loss_bc::BC,
        loss_collocation::C, resid_bc, resid_collocation, L::Int, p
    ) where {BC, C}
    DI.jacobian!(
        loss_bc, resid_bc, @view(J[1:L, :]), bc_diffcache, bc_diffmode, x, Constant(p)
    )
    DI.jacobian!(
        loss_collocation, resid_collocation, @view(J[(L + 1):end, :]),
        nonbc_diffcache, nonbc_diffmode, x, Constant(p)
    )
    return nothing
end

function __mirkn_mpoint_jacobian(
        J, _, x, bc_diffmode, nonbc_diffmode, bc_diffcache, nonbc_diffcache,
        loss_bc::BC, loss_collocation::C, L::Int, p
    ) where {BC, C}
    DI.jacobian!(loss_bc, @view(J[1:L, :]), bc_diffcache, bc_diffmode, x, Constant(p))
    DI.jacobian!(
        loss_collocation, @view(J[(L + 1):end, :]),
        nonbc_diffcache, nonbc_diffmode, x, Constant(p)
    )
    return J
end

@views function __mirkn_loss!(
        resid, u, p, y, pt::StandardSecondOrderBVProblem, bc::BC,
        residual, mesh, cache::MIRKNCache, EvalSol, EvalDSol
    ) where {BC}
    y_ = recursive_unflatten!(y, u)
    resids = [get_tmp(r, u) for r in residual]
    Φ!(resids[3:end], cache, y_, u, p)
    EvalSol.u[1:end] .= __restructure_sol(y_[1:length(cache.mesh)], cache.in_size)
    EvalSol.cache.k_discrete[1:end] .= cache.k_discrete
    EvalDSol.u[1:end] .= __restructure_sol(y_[(length(cache.mesh) + 1):end], cache.in_size)
    EvalDSol.cache.k_discrete[1:end] .= cache.k_discrete
    eval_bc_residual!(resids[1:2], pt, bc, EvalSol, EvalDSol, p, mesh)
    recursive_flatten!(resid, resids)
    return nothing
end

@views function __mirkn_loss(
        u, p, y, pt::StandardSecondOrderBVProblem, bc::BC,
        mesh, cache::MIRKNCache, EvalSol, EvalDSol
    ) where {BC}
    y_ = recursive_unflatten!(y, u)
    resid_co = Φ(cache, y_, u, p)
    EvalSol.u[1:end] .= __restructure_sol(y_[1:length(cache.mesh)], cache.in_size)
    EvalSol.cache.k_discrete[1:end] .= cache.k_discrete
    EvalDSol.u[1:end] .= __restructure_sol(y_[(length(cache.mesh) + 1):end], cache.in_size)
    EvalDSol.cache.k_discrete[1:end] .= cache.k_discrete
    resid_bc = eval_bc_residual(pt, bc, EvalSol, EvalDSol, p, mesh)
    return vcat(resid_bc, mapreduce(vec, vcat, resid_co))
end

@views function __mirkn_loss_bc!(
        resid, u, p, pt, bc!::BC, y, mesh, cache::MIRKNCache
    ) where {BC}
    y_ = recursive_unflatten!(y, u)
    soly_ = EvalSol(__restructure_sol(y_[1:length(cache.mesh)], cache.in_size), mesh, cache)
    dsoly_ = EvalSol(__restructure_sol(y_[(length(cache.mesh) + 1):end], cache.in_size), cache.mesh, cache)
    eval_bc_residual!(resid, pt, bc!, soly_, dsoly_, p, mesh)
    return nothing
end

@views function __mirkn_loss_bc(u, p, pt, bc!::BC, y, mesh, cache::MIRKNCache) where {BC}
    y_ = recursive_unflatten!(y, u)
    soly_ = EvalSol(__restructure_sol(y_[1:length(cache.mesh)], cache.in_size), mesh, cache)
    dsoly_ = EvalSol(__restructure_sol(y_[(length(cache.mesh) + 1):end], cache.in_size), cache.mesh, cache)
    return eval_bc_residual(pt, bc!, soly_, dsoly_, p, mesh)
end

@views function __mirkn_loss_collocation!(resid, u, p, y, mesh, residual, cache)
    y_ = recursive_unflatten!(y, u)
    resids = [get_tmp(r, u) for r in residual[3:end]]
    Φ!(resids, cache, y_, u, p)
    recursive_flatten!(resid, resids)
    return nothing
end

@views function __mirkn_loss_collocation(u, p, y, mesh, residual, cache)
    y_ = recursive_unflatten!(y, u)
    resids = Φ(cache, y_, u, p)
    return mapreduce(vec, vcat, resids)
end

@views function __mirkn_loss!(
        resid, u, p, y, pt::TwoPointSecondOrderBVProblem, bc!::BC,
        residual, mesh, cache::MIRKNCache, _, _
    ) where {BC}
    y_ = recursive_unflatten!(y, u)
    resids = [get_tmp(r, u) for r in residual]
    Φ!(resids[3:end], cache, y_, u, p)
    eval_bc_residual!(resids[1:2], pt, bc!, y_, p, mesh)
    recursive_flatten!(resid, resids)
    return nothing
end

@views function __mirkn_loss(
        u, p, y, pt::TwoPointSecondOrderBVProblem,
        bc!::BC, mesh, cache::MIRKNCache, _, _
    ) where {BC}
    y_ = recursive_unflatten!(y, u)
    resid_co = Φ(cache, y_, u, p)
    resid_bc = eval_bc_residual(pt, bc!, y_, p, mesh)
    return vcat(resid_bc, mapreduce(vec, vcat, resid_co))
end

module BoundaryValueDiffEqMIRKN

using ADTypes: ADTypes, AutoSparse, AutoForwardDiff
using ArrayInterface: fast_scalar_indexing
using BandedMatrices: BandedMatrix, Ones
using BoundaryValueDiffEqCore: AbstractBoundaryValueDiffEqAlgorithm,
    AbstractBoundaryValueDiffEqCache, BVPJacobianAlgorithm,
    recursive_flatten, recursive_flatten!, recursive_unflatten!,
    __concrete_solve_algorithm, diff!, EvalSol, eval_bc_residual,
    eval_bc_residual!, get_tmp, __maybe_matmul!,
    __extract_problem_details, __initial_guess,
    __maybe_allocate_diffcache, __restructure_sol,
    __get_bcresid_prototype, safe_similar, __vec, __vec_f,
    __vec_f!, __vec_bc, __vec_bc!, __vec_so_bc!, __vec_so_bc,
    recursive_flatten_twopoint!, __internal_nlsolve_problem,
    __extract_mesh, __extract_u0, __has_initial_guess,
    __initial_guess_length, __initial_guess_on_mesh,
    __flatten_initial_guess, __build_solution, __Fix3,
    __default_sparse_ad, __default_nonsparse_ad, get_dense_ad,
    concrete_jacobian_algorithm, __default_coloring_algorithm,
    __default_sparsity_detector, interval, __split_kwargs,
    NoErrorControl, __construct_internal_problem,
    __concrete_kwargs, __internal_solve

using ConcreteStructs: @concrete
using DifferentiationInterface: DifferentiationInterface, Constant, prepare_jacobian
using FastAlmostBandedMatrices: AlmostBandedMatrix, fillpart, exclusive_bandpart,
    finish_part_setindex!
using FastClosures: @closure
using ForwardDiff: ForwardDiff, pickchunksize, Dual
using LinearAlgebra
using PreallocationTools: PreallocationTools, DiffCache
using PrecompileTools: @compile_workload, @setup_workload
using Preferences: Preferences
using RecursiveArrayTools: AbstractVectorOfArray, VectorOfArray, recursivecopy,
    ArrayPartition
using Reexport: @reexport
using SciMLBase: SciMLBase, AbstractDiffEqInterpolation, AbstractBVProblem,
    StandardSecondOrderBVProblem, StandardBVProblem, __solve, _unwrap_val
using Setfield: @set!, @set
using SparseArrays: sparse

const DI = DifferentiationInterface

@reexport using ADTypes, BoundaryValueDiffEqCore, SciMLBase

include("types.jl")
include("algorithms.jl")
include("mirkn.jl")
include("alg_utils.jl")
include("collocation.jl")
include("mirkn_tableaus.jl")
include("interpolation.jl")

export MIRKN4, MIRKN6

end

# Intermediate solution for evaluating boundary conditions
# basically simplified version of the linear interpolation for MIRKN
function (s::EvalSol{C})(tval::Number) where {C <: MIRKNCache}
    (; t, u, cache) = s

    # Quick handle for the case where tval is at the boundary
    (tval == t[1]) && return first(u)
    (tval == t[end]) && return last(u)
    # Linear interpolation
    i = interval(tval, t)
    dt = t[i + 1] - t[i]
    τ = (tval - t[i]) / dt
    z = τ * u[i + 1] + (1 - τ) * u[i]
    return z
end

# MIRKN Method Tableaus
struct MIRKNTableau{sType, cType, vType, wType, bType, xType, vpType, bpType, xpType}
    """Discrete stages of MIRKN formula"""
    s::sType
    c::cType
    v::vType
    w::wType
    b::bType
    x::xType
    vp::vpType
    bp::bpType
    xp::xpType

    function MIRKNTableau(s, c, v, w, b, x, vp, bp, xp)
        @assert eltype(c) ==
            eltype(v) ==
            eltype(w) ==
            eltype(b) ==
            eltype(x) ==
            eltype(vp) ==
            eltype(bp) ==
            eltype(xp)
        return new{
            typeof(s), typeof(c), typeof(v), typeof(w), typeof(b),
            typeof(x), typeof(vp), typeof(bp), typeof(xp),
        }(s, c, v, w, b, x, vp, bp, xp)
    end
end

@views function Φ!(residual, cache::MIRKNCache, y, u, p = cache.p)
    return Φ!(
        residual, cache.fᵢ_cache, cache.fᵢ₂_cache, cache.k_discrete,
        cache.f, cache.TU, y, u, p, cache.mesh, cache.mesh_dt, cache.stage
    )
end

@views function Φ!(
        residual, fᵢ_cache, fᵢ₂_cache, k_discrete, f!,
        TU::MIRKNTableau, y, u, p, mesh, mesh_dt, stage::Int
    )
    (; c, v, w, b, x, vp, bp, xp) = TU
    L = length(mesh)
    T = eltype(u)
    tmp = get_tmp(fᵢ_cache, u)
    tmpd = get_tmp(fᵢ₂_cache, u)
    for i in 1:(L - 1)
        dtᵢ = mesh_dt[i]
        yᵢ = get_tmp(y[i], u)
        yᵢ₊₁ = get_tmp(y[i + 1], u)
        yₗ₊ᵢ = get_tmp(y[L + i], u)
        yₗ₊ᵢ₊₁ = get_tmp(y[L + i + 1], u)
        K = get_tmp(k_discrete[i], u)
        for r in 1:stage
            @. tmp = (1 - v[r]) * yᵢ +
                v[r] * yᵢ₊₁ +
                dtᵢ * ((c[r] - v[r] - w[r]) * yₗ₊ᵢ + w[r] * yₗ₊ᵢ₊₁)
            @. tmpd = (1 - vp[r]) * yₗ₊ᵢ + vp[r] * yₗ₊ᵢ₊₁
            __maybe_matmul!(tmp, K[:, 1:(r - 1)], x[r, 1:(r - 1)], dtᵢ^2, T(1))
            __maybe_matmul!(tmpd, K[:, 1:(r - 1)], xp[r, 1:(r - 1)], dtᵢ, T(1))
            f!(K[:, r], tmpd, tmp, p, mesh[i] + c[r] * dtᵢ)
        end

        # Update residual
        @. residual[i] = yᵢ₊₁ - yᵢ - dtᵢ * yₗ₊ᵢ
        __maybe_matmul!(residual[i], K[:, 1:stage], b[1:stage], -dtᵢ^2, T(1))
        @. residual[L + i - 1] = yₗ₊ᵢ₊₁ - yₗ₊ᵢ
        __maybe_matmul!(residual[L + i - 1], K[:, 1:stage], bp[1:stage], -dtᵢ, T(1))
    end
end

function Φ(cache::MIRKNCache, y, u, p = cache.p)
    return Φ(
        cache.fᵢ_cache, cache.fᵢ₂_cache, cache.k_discrete, cache.f,
        cache.TU, y, u, p, cache.mesh, cache.mesh_dt, cache.stage
    )
end

@views function Φ(
        fᵢ_cache, fᵢ₂_cache, k_discrete, f, TU::MIRKNTableau,
        y, u, p, mesh, mesh_dt, stage::Int
    )
    (; c, v, w, b, x, vp, bp, xp) = TU
    residual = [similar(yᵢ) for yᵢ in y[1:(end - 2)]]
    L = length(mesh)
    T = eltype(u)
    tmp = get_tmp(fᵢ_cache, u)
    tmpd = get_tmp(fᵢ₂_cache, u)
    for i in 1:(L - 1)
        dtᵢ = mesh_dt[i]
        yᵢ = get_tmp(y[i], u)
        yᵢ₊₁ = get_tmp(y[i + 1], u)
        yₗ₊ᵢ = get_tmp(y[L + i], u)
        yₗ₊ᵢ₊₁ = get_tmp(y[L + i + 1], u)
        K = get_tmp(k_discrete[i], u)
        for r in 1:stage
            @. tmp = (1 - v[r]) * yᵢ +
                v[r] * yᵢ₊₁ +
                dtᵢ * ((c[r] - v[r] - w[r]) * yₗ₊ᵢ + w[r] * yₗ₊ᵢ₊₁)
            @. tmpd = (1 - vp[r]) * yₗ₊ᵢ + vp[r] * yₗ₊ᵢ₊₁
            __maybe_matmul!(tmp, K[:, 1:(r - 1)], x[r, 1:(r - 1)], dtᵢ^2, T(1))
            __maybe_matmul!(tmpd, K[:, 1:(r - 1)], xp[r, 1:(r - 1)], dtᵢ, T(1))

            K[:, r] .= f(tmpd, tmp, p, mesh[i] + c[r] * dtᵢ)
        end
        @. residual[i] = yᵢ₊₁ - yᵢ - dtᵢ * yₗ₊ᵢ
        __maybe_matmul!(residual[i], K[:, 1:stage], b[1:stage], -dtᵢ^2, T(1))
        @. residual[L + i - 1] = yₗ₊ᵢ₊₁ - yₗ₊ᵢ
        __maybe_matmul!(residual[L + i - 1], K[:, 1:stage], bp[1:stage], -dtᵢ, T(1))
    end
    return residual
end

@testsetup module MIRKNConvergenceTests

using BoundaryValueDiffEqMIRKN

for order in (4, 6)
    s = Symbol("MIRKN$(order)")
    @eval mirkn_solver(::Val{$order}, args...; kwargs...) = $(s)(args...; kwargs...)
end

function f!(ddu, du, u, p, t)
    ddu[1] = u[1]
end
function f(du, u, p, t)
    return u[1]
end
function bc!(res, du, u, p, t)
    res[1] = u(0.0)[1] - 1
    res[2] = u(1.0)[1]
end
function bc(du, u, p, t)
    return [u(0.0)[1] - 1, u(1.0)[1]]
end
function bc_indexing!(res, du, u, p, t)
    res[1] = u[:, 1][1] - 1
    res[2] = u[:, end][1]
end
function bc_indexing(du, u, p, t)
    return [u[:, 1][1] - 1, u[:, end][1]]
end
function bc_a!(res, du, u, p)
    res[1] = u[1] - 1
end
function bc_b!(res, du, u, p)
    res[1] = u[1]
end
function bc_a(du, u, p)
    return [u[1] - 1]
end
function bc_b(du, u, p)
    return [u[1]]
end
analytical_solution = (
    u0, p,
    t,
) -> [(exp(-t) - exp(t - 2)) / (1 - exp(-2)), (-exp(-t) - exp(t - 2)) / (1 - exp(-2))]
u0 = [1.0]
tspan = (0.0, 1.0)
testTol = 0.2
bvpf1 = DynamicalBVPFunction(f!, bc!, analytic = analytical_solution)
bvpf2 = DynamicalBVPFunction(f, bc, analytic = analytical_solution)
bvpf3 = DynamicalBVPFunction(f!, bc_indexing!, analytic = analytical_solution)
bvpf4 = DynamicalBVPFunction(f, bc_indexing, analytic = analytical_solution)
bvpf5 = DynamicalBVPFunction(
    f!, (bc_a!, bc_b!), analytic = analytical_solution,
    bcresid_prototype = (zeros(1), zeros(1)), twopoint = Val(true)
)
bvpf6 = DynamicalBVPFunction(
    f, (bc_a, bc_b), analytic = analytical_solution,
    bcresid_prototype = (zeros(1), zeros(1)), twopoint = Val(true)
)
probArr = [
    SecondOrderBVProblem(bvpf1, u0, tspan), SecondOrderBVProblem(bvpf2, u0, tspan),
    SecondOrderBVProblem(bvpf3, u0, tspan), SecondOrderBVProblem(bvpf4, u0, tspan),
    TwoPointSecondOrderBVProblem(bvpf5, u0, tspan),
    TwoPointSecondOrderBVProblem(bvpf6, u0, tspan),
]
dts = 1 .// 2 .^ (3:-1:1)

export probArr, dts, testTol, mirkn_solver

end

@testitem "Convergence on Linear" setup = [MIRKNConvergenceTests] begin
    using LinearAlgebra, DiffEqDevTools

    @testset "Problem: $i" for i in (1, 2, 3, 4, 5, 6)
        prob = probArr[i]
        @testset "MIRKN$order" for order in (4, 6)
            sim = test_convergence(
                dts, prob, mirkn_solver(Val(order)); abstol = 1.0e-8, reltol = 1.0e-8
            )
            @test sim.𝒪est[:final] ≈ order atol = testTol
        end
    end
end

# JET tests have been moved to the separate QA test group (test/qa/)

@testitem "Example problem from paper" begin
    using BoundaryValueDiffEqMIRKN

    for order in (4, 6)
        s = Symbol("MIRKN$(order)")
        @eval mirkn_solver(::Val{$order}, args...; kwargs...) = $(s)(args...; kwargs...)
    end

    function test!(ddu, du, u, p, t)
        ϵ = 0.1
        ddu[1] = u[2]
        ddu[2] = (-u[1] * du[2] - u[3] * du[3]) / ϵ
        ddu[3] = (du[1] * u[3] - u[1] * du[3]) / ϵ
    end
    function test(du, u, p, t)
        ϵ = 0.1
        return [u[2], (-u[1] * du[2] - u[3] * du[3]) / ϵ, (du[1] * u[3] - u[1] * du[3]) / ϵ]
    end

    function bc!(res, du, u, p, t)
        res[1] = u(0.0)[1]
        res[2] = u(1.0)[1]
        res[3] = u(0.0)[3] + 1
        res[4] = u(1.0)[3] - 1
        res[5] = du(0.0)[1]
        res[6] = du(1.0)[1]
    end

    function bc(du, u, p, t)
        return [u(0.0)[1], u(1.0)[1], u(0.0)[3] + 1, u(1.0)[3] - 1, du(0.0)[1], du(1.0)[1]]
    end

    function bc_indexing!(res, du, u, p, t)
        res[1] = u[:, 1][1]
        res[2] = u[:, end][1]
        res[3] = u[:, 1][3] + 1
        res[4] = u[:, end][3] - 1
        res[5] = du[:, 1][1]
        res[6] = du[:, end][1]
    end

    function bc_indexing(du, u, p, t)
        return [
            u[:, 1][1], u[:, end][1], u[:, 1][3] + 1,
            u[:, end][3] - 1, du[:, 1][1], du[:, end][1],
        ]
    end

    function bca!(resa, du, u, p)
        resa[1] = u[1]
        resa[2] = u[3] + 1
        resa[3] = du[1]
    end
    function bcb!(resb, du, u, p)
        resb[1] = u[1]
        resb[2] = u[3] - 1
        resb[3] = du[1]
    end

    function bca(du, u, p)
        [u[1], u[3] + 1, du[1]]
    end
    function bcb(du, u, p)
        [u[1], u[3] - 1, du[1]]
    end

    u0 = [1.0, 1.0, 1.0]
    tspan = (0.0, 1.0)

    probArr = [
        SecondOrderBVProblem(test!, bc!, u0, tspan),
        SecondOrderBVProblem(test, bc, u0, tspan),
        SecondOrderBVProblem(test!, bc_indexing!, u0, tspan),
        SecondOrderBVProblem(test, bc_indexing, u0, tspan),
        TwoPointSecondOrderBVProblem(
            test!, (bca!, bcb!), u0, tspan, bcresid_prototype = (zeros(3), zeros(3))
        ),
        TwoPointSecondOrderBVProblem(
            test, (bca, bcb), u0, tspan, bcresid_prototype = (zeros(3), zeros(3))
        ),
    ]

    @testset "MIRKN$order" for order in (4, 6)
        @testset "Problem $i" for i in 1:6
            sol = solve(probArr[i], mirkn_solver(Val(order)); dt = 0.01)
            @test SciMLBase.successful_retcode(sol)
        end
    end
end

@testitem "Test initial guess" begin
    function f!(ddu, du, u, p, t)
        ε = 0.1
        ddu[1] = u[2]
        ddu[2] = (-u[1] * du[2] - u[3] * du[3]) / ε
        ddu[3] = (du[1] * u[3] - u[1] * du[3]) / ε
    end
    function bc!(res, du, u, p, t)
        res[1] = u(0.0)[1]
        res[2] = u(1.0)[1]
        res[3] = u(0.0)[3] + 1
        res[4] = u(1.0)[3] - 1
        res[5] = du(0.0)[1]
        res[6] = du(1.0)[1]
    end
    u0 = [1.0, 1.0, 1.0]
    tspan = (0.0, 1.0)
    prob = SecondOrderBVProblem(f!, bc!, u0, tspan)
    sol1 = solve(prob, MIRKN4(), dt = 0.01, adaptive = false)

    guess = getindex.(getfield.(sol1.u, :x), 1)
    prob_with_guess = SecondOrderBVProblem(f!, bc!, guess, tspan)
    sol2 = solve(prob_with_guess, MIRKN4(), dt = 0.01, adaptive = false, nlsolve_kwargs = (; maxiters = 0))

    # Only test the initial guess, instead of the full solution with derivative solution, since no iterations are performed
    sol2u = getindex.(getfield.(sol2.u, :x), 1)
    @test sol2u == guess
end

# Algorithms
abstract type AbstractMIRKN <: AbstractBoundaryValueDiffEqAlgorithm end

for order in (4, 6)
    alg = Symbol("MIRKN$(order)")

    @eval begin
        """
            $($alg)(; nlsolve = NewtonRaphson(), optimize = nothing, jac_alg = BVPJacobianAlgorithm(),
                    defect_threshold = 0.1, max_num_subintervals = 3000)

        $($order)th order Monotonic Implicit Runge Kutta Nyström method.

        ## Keyword Arguments

        - `nlsolve`: Internal Nonlinear solver. Any solver which conforms to the SciML
          `NonlinearProblem` interface can be used. Note that any autodiff argument for
          the solver will be ignored and a custom jacobian algorithm will be used.
        - `optimize`: Internal Optimization solver. Any solver which conforms to the SciML
          `OptimizationProblem` interface can be used. Note that any autodiff argument for
          the solver will be ignored and a custom jacobian algorithm will be used. Optimization
          solvers should first be loaded to allow this functionality.
        - `jac_alg`: Jacobian Algorithm used for the nonlinear solver. Defaults to
          `BVPJacobianAlgorithm()`, which automatically decides the best algorithm to
          use based on the input types and problem type.
          - For `TwoPointBVProblem`, only `diffmode` is used (defaults to
            `AutoSparse(AutoForwardDiff())` if possible else `AutoSparse(AutoFiniteDiff())`).
          - For `BVProblem`, `bc_diffmode` and `nonbc_diffmode` are used. For
            `nonbc_diffmode` defaults to `AutoSparse(AutoForwardDiff())` if possible else
            `AutoSparse(AutoFiniteDiff())`. For `bc_diffmode`, defaults to `AutoForwardDiff` if
            possible else `AutoFiniteDiff`.
        - `defect_threshold`: Threshold for defect control.
        - `max_num_subintervals`: Number of maximal subintervals, default as 3000.

        !!! note

            For type-stability, the chunksizes for ForwardDiff ADTypes in
            `BVPJacobianAlgorithm` must be provided.

        ## References

        ```bibtex
        @article{Muir2001MonoImplicitRM,
            title={Mono-Implicit Runge-Kutta-Nystr{\"o}m Methods with Application to Boundary Value Ordinary Differential Equations},
            author={Paul H. Muir and Mark F. Adams},
            journal={BIT Numerical Mathematics},
            year={2001},
            volume={41},
            pages={776-799}
        }
        ```
        """
        @kwdef struct $(alg){N, O, J <: BVPJacobianAlgorithm, T} <: AbstractMIRKN
            nlsolve::N = nothing
            optimize::O = nothing
            jac_alg::J = BVPJacobianAlgorithm()
            defect_threshold::T = 0.1
            max_num_subintervals::Int = 3000
        end
    end
end
